/*******************************************************************************
 * FoxWeaponMagazine_Base generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeaponMagazine_Base extends FoxWeaponModObjectBase
    native(Weapon)
    config(Magazine);

var name ReloadType;
var name ReloadName;
var name HangerReloadName;
var bool bAllowShortReload;
var bool bAllowCamo;
var bool bHiddenOverride;
var bool bFPShouldBeVisible;
var bool bTPShouldBeVisible;

simulated function bool BuildFromDataProvider(FoxDataProvider_ModBase ModBase)
{
    local FoxDataProvider_Magazine MagProvider;

    MagProvider = FoxDataProvider_Magazine(ModBase);
    // End:0x18F
    if(MagProvider != none)
    {
        // End:0x7F
        if(MagProvider.ReloadType != 'None')
        {
            ReloadType = MagProvider.ReloadType;
        }
        // End:0xD3
        if(MagProvider.ReloadName != 'None')
        {
            ReloadName = MagProvider.ReloadName;
        }
        // End:0x127
        if(MagProvider.HangerReloadName != 'None')
        {
            HangerReloadName = MagProvider.HangerReloadName;
        }
        bAllowShortReload = MagProvider.bAllowShortReload;
        bAllowCamo = MagProvider.bAllowCamo;
        return super.BuildFromDataProvider(ModBase);
    }
    return false;
    //return ReturnValue;    
}

function UpdateSpawnEffectMaterials(const name ParamName, const float Value, const int stage)
{
    local int I;

    // End:0xCB
    if(FPMesh != none)
    {
        I = 0;
        J0x1A:
        // End:0xC8 [Loop If]
        if(I < FPSpawnFXStageOne.Length)
        {
            // End:0x7F
            if(stage == 0)
            {
                FPSpawnFXStageOne[I].SetScalarParameterValue(ParamName, Value);
            }
            // End:0xBA
            else
            {
                FPSpawnFXStageTwo[I].SetScalarParameterValue(ParamName, Value);
            }
            ++ I;
            // [Loop Continue]
            goto J0x1A;
        }
    }
    // End:0x193
    else
    {
        // End:0x193
        if(TPMesh != none)
        {
            I = 0;
            J0xE5:
            // End:0x193 [Loop If]
            if(I < TPSpawnFXStageOne.Length)
            {
                // End:0x14A
                if(stage == 0)
                {
                    TPSpawnFXStageOne[I].SetScalarParameterValue(ParamName, Value);
                }
                // End:0x185
                else
                {
                    TPSpawnFXStageTwo[I].SetScalarParameterValue(ParamName, Value);
                }
                ++ I;
                // [Loop Continue]
                goto J0xE5;
            }
        }
    }
    //return;    
}

function SetupWeaponCamo(int CamoIndex)
{
    local int I;

    // End:0x22
    if(bAllowCamo)
    {
        super.SetupWeaponCamo(CamoIndex);
        return;
    }
    FPCamoMICs.Length = 0;
    TPCamoMICs.Length = 0;
    // End:0xC4
    if(FPMesh != none)
    {
        I = 0;
        J0x54:
        // End:0xC4 [Loop If]
        if(I < FPMesh.GetNumElements())
        {
            FPCamoMICs.AddItem(FPMesh.CreateAndSetMaterialInstanceConstant(I));
            ++ I;
            // [Loop Continue]
            goto J0x54;
        }
    }
    // End:0x14E
    if(TPMesh != none)
    {
        I = 0;
        J0xDE:
        // End:0x14E [Loop If]
        if(I < TPMesh.GetNumElements())
        {
            TPCamoMICs.AddItem(TPMesh.CreateAndSetMaterialInstanceConstant(I));
            ++ I;
            // [Loop Continue]
            goto J0xDE;
        }
    }
    //return;    
}

function SetVisibility(const bool bFPVisible, const bool bTPVisible)
{
    bFPShouldBeVisible = bFPVisible;
    bTPShouldBeVisible = bTPVisible;
    // End:0x86
    if((FPMesh != none) && !bHiddenOverride || !bFPVisible)
    {
        FPMesh.SetHidden(!bFPVisible);
    }
    // End:0xE2
    if((TPMesh != none) && !bHiddenOverride || !bTPVisible)
    {
        TPMesh.SetHidden(!bTPVisible);
    }
    //return;    
}

function SetHiddenOverride(bool bNewOverride)
{
    bHiddenOverride = bNewOverride;
    // End:0x83
    if(bHiddenOverride)
    {
        // End:0x51
        if(FPMesh != none)
        {
            FPMesh.SetHidden(true);
        }
        // End:0x80
        if(TPMesh != none)
        {
            TPMesh.SetHidden(true);
        }
    }
    // End:0xF7
    else
    {
        // End:0xBD
        if(FPMesh != none)
        {
            FPMesh.SetHidden(!bFPShouldBeVisible);
        }
        // End:0xF7
        if(TPMesh != none)
        {
            TPMesh.SetHidden(!bTPShouldBeVisible);
        }
    }
    //return;    
}

defaultproperties
{
    ReloadType=Reloading
    begin object name=NewFPMesh class=FoxFirstPersonSkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeaponMagazine_Base.NewFPMesh'
    FPMesh=NewFPMesh
    begin object name=NewTPMesh class=SkeletalMeshComponent
        bForceRefpose=1
        bNoSkeletonUpdate=true
        bUpdateSkelWhenNotRendered=false
        bIgnoreControllersWhenNotRendered=true
        bOverrideAttachmentOwnerVisibility=true
        ReplacementPrimitive=none
        MaxDrawDistance=12000.0
        CachedMaxDrawDistance=12000.0
        TickGroup=ETickingGroup.TG_DuringAsyncWork
    object end
    // Reference: SkeletalMeshComponent'Default__FoxWeaponMagazine_Base.NewTPMesh'
    TPMesh=NewTPMesh
    PreviewRotation=(Pitch=512,Yaw=5760,Roll=0)
}